Ce n'est pas une demande, mais une suggestion. Et si ¢a intéresse du monde, je suis prét a aider.

La possibilité d'envoyer un mail aux éléves avec leur copie annotée est une fonctionnalité trés intéressante
d'’AMC (lorsqu'on arrive a la faire fonctionner ;)). Cependant, I'envoi massif de mails, surtout lorsque chacun
contenant une pj, n'est pas toujours bien vu des administrateurs de messagerie. L'envoi en nombre non plus
(je me suis fait blacklister sur mon serveur d'envoi), d'ou les demandes qui ont été faites dans cette liste
d'ajout de fonctionnalités de temporisation dans I'envoi de mail.

J'ai donc pensé a une autre méthode qui allege un peu la charge des serveurs de messagerie, et pour pour
laquelle j'ai une méthode (script) qui fonctionne, mais qui a l'inconvénient pour l'instant de ne pas étre
intégrée a AMC.

De nombreuses institutions d'enseignement ont une plateforme de partage de documents, qui, pour les plus
répandues, disposent d'une API. Chez moi c'est Owncloud (mais on peut aussi penser a Dropbox). J'ai ainsi
écrit un script qui vient prendre le relais du flux AMC a partir du moment ou les copies sont corrigées et
annotées (fichiers pdf sous la forme xyz-Nom-Prenom.pdf) afin de les mettre a disposition des éleves et de
les en informer (et leur donner leur note).

Le script effectue 2 choses :

1. Il uploade chaque fichier pdf (copie annotée) sur le serveur owncloud et définit un partage sur ce fichier
(par lien + mot de passe)

2. Il envoie un mail personnalisé a chaque éléve en lui indiquant sa note et le lien + mot de passe nécessaires
pour télécharger sa copie depuis le serveur owncloud

Pour l'instant, si on regarde les détails,

1. le mot de passe est généré aléatoirement et on utilise I'API owncloud
(https://docs.nextcloud.com/server/9/developer_manual/core/ocs-share-api.html) pour effectuer I'upload,
définir le mot de passe, le mode de partage (lien+mot de passe) et pour récupérer le lien défini par owncloud

2. le mail est pré-rédigé et contient les variables
* adresse de ['éleve

* la date du test

* prénom de I'éleve

* note de I'éléve

* lien du partage owncloud sur la copie de I'éleve
* mot de passe sur ce partage

Par exemple :

Bonjour $prenom

Votre note au test du $date est $note. Vous pouvez récupérer votre au
copie au lien suivant :

1/5



$lien
Le mot de passe pour accéder a ce lien est $passwd

Cordialement
Signature

L'adresse est forgée en utilisant le nom du fichier pdf, car les adresses des éléves sont formatées
prenom.nom@institution.fr. Mais on
peut trés bien les extraire d'un fichier (p.ex. comme lorsqu'on utilise la fonctionnalité d'envoi par mail d'AMC)

Le mail est envoyé par msmtp

De plus, le script temporise I'envoi de mail. Je n'ai le droit d'envoyer que N mails par heure. Donc le script
effectue une pause d'une heure dans I'envoi de mails tous les (N-1) mails.

Voila. Je me disais que ce serait bien d'intégrer un truc du genre dans AMC, mais je ne sais pas faire....

History

09/22/2016 09:16 pm - Alexis Bienveniie
- Tracker changed from Bug to Feature

09/22/2016 09:17 pm - Alexis Bienveniie
- Description changed from Bonjour,

Ce n'est pas une demande, mais une suggestion. Et si A§a intA@resse du monde, je suis prA2t Al aider.

La possibilitA® d'envoyer un mail aux AGIA ves avec leur copie annotAQe est une fonctionnalitA®© trA’s intA@ressante d'AMC (lorsqu'on arrive Al la
faire fonctionner ;)). Cependant, I'envoi massif de mails, surtout lorsque chacun contenant une pj, n'est pas toujours bien vu des administrateurs de
messagerie. L'envoi en nombre non plus (je me suis fait blacklister sur mon serveur d'envoi), d'oA" les demandes qui ont AOtA® faites dans cette liste

d'ajout de fonctionnalitA@s de temporisation dans I'envoi de mail.

J'ai donc pensA© Al une autre mA®@thode qui allA"ge un peu la charge des serveurs de messagerie, et pour pour laquelle j'ai une mA®@thode (script)
qui fonctionne, mais qui a l'inconvA®@nient pour l'instant de ne pas A2tre intA@grA©e A1 AMC.

De nombreuses institutions d'enseignement ont une plateforme de partage de documents, qui, pour les plus rA@pandues, disposent d'une API. Chez
moi c'est Owncloud (mais on peut aussi penser Al Dropbox). J'ai ainsi A@crit un script qui vient prendre le relais du flux AMC Al partir du moment oA’
les copies sont corrigA®@es et annotA®es (fichiers pdf sous la forme xyz-Nom-Prenom.pdf) afin de les mettre Al disposition des AGIA ves et de les en

informer (et leur donner leur note).

Le script effectue 2 choses :

1. Il uploade chaque fichier pdf (copie annotA®e) sur le serveur owncloud et dACfinit un partage sur ce fichier (par lien + mot de passe)

2. Il envoie un mail personnalisA© Al chaque A©IA ve en lui indiquant sa note et le lien + mot de passe nA@cessaires pour tA@IA@charger sa copie
depuis le serveur owncloud

Pour l'instant, si on regarde les dA®tails,

1. le mot de passe est gA@nAGrA® alA@atoirement et on utilise I'API owncloud
([[https ://docs. nextcloud.com/server/9/developer_manual/core/ocs-share-api.html]]) pour effectuer I'upload, dA®finir le mot de passe, le mode de

partage (lien+mot de passe) et pour rA@cupA@rer le lien dA©fini par owncloud

2. le mail est prA©-rA@digA® et contient les variables
* adresse de I'AGIA"ve

* la date du test

* prA®nom de I'AGIA ve

* note de I'AGIA ve

* lien du partage owncloud sur la copie de I'AGIA ve

* mot de passe sur ce partage
Par exemple :
Bonjour $prenom

Votre note au test du $date est $note. Vous pouvez rA@cupACrer votre au

copie au lien suivant :
$lien
Le mot de passe pour accA@der Al ce lien est $passwd

Cordialement
Signature

L'adresse est forgA®@e en utilisant le nom du fichier pdf, car les adresses des A@IA ves sont formatA@es prenom.nom@institution.fr. Mais on
peut trA’s bien les extraire d'un fichier (p.ex. comme lorsqu'on utilise la fonctionnalitA® d'envoi par mail d'AMC)
Le mail est envoyA® par msmtp

De plus, le script temporise I'envoi de mail. Je n‘ai le droit d'envoyer que N mails par heure. Donc le script effectue une pause d'une heure dans I'envoi

de mails tous les (N-1) mails.

VoilAl . Je me disais que ce serait bien d'intA@grer un truc du genre dans AMC, mais je ne sais pas faire....

to Bonjour,
Ce n'est pas une demande, mais une suggestion. Et si A§a intA@resse du monde, je suis prA2t Al aider.

La possibilitA® d'envoyer un mail aux AGIA ves avec leur copie annotA@e est une fonctionnalitA®© trA’s intA@ressante d'AMC (lorsqu'on arrive AD la
faire fonctionner ;)). Cependant, I'envoi massif de mails, surtout lorsque chacun contenant une pj, n'est pas toujours bien vu des administrateurs de
messagerie. L'envoi en nombre non plus (je me suis fait blacklister sur mon serveur d'envoi), d'0A" les demandes qui ont AGtA® faites dans cette liste

d'ajout de fonctionnalitA@s de temporisation dans I'envoi de mail.

J'ai donc pensA® Al une autre mA©thode qui allA"ge un peu la charge des serveurs de messagerie, et pour pour laquelle j'ai une mA®©thode (script)
qui fonctionne, mais qui a I'inconvA®@nient pour l'instant de ne pas Aétre intA©grA©e Al AMC.

De nombreuses institutions d'enseignement ont une plateforme de partage de documents, qui, pour les plus rA@pandues, disposent d'une API. Chez
moi c'est Owncloud (mais on peut aussi penser Al Dropbox). J'ai ainsi A@crit un script qui vient prendre le relais du flux AMC Al partir du moment oA’
les copies sont corrigA®@es et annotA®@es (fichiers pdf sous la forme xyz-Nom-Prenom.pdf) afin de les mettre Al disposition des A©IA ves et de les en

informer (et leur donner leur note).
Le script effectue 2 choses :

1. Il uploade chaque fichier pdf (copie annotA®©e) sur le serveur owncloud et dA©finit un partage sur ce fichier (par lien + mot de passe)

2. Il envoie un mail personnalisA© Al chaque A©IA ve en lui indiquant sa note et le lien + mot de passe nA@cessaires pour tA@IA@charger sa copie
depuis le serveur owncloud

Pour l'instant, si on regarde les dA®tails,

1. le mot de passe est gA@nACrA®© alA@atoirement et on utilise I'API owncloud
(https://docs.nextcloud.com/server/9/developer_manual/core/ocs-share-api.html) pour effectuer I'upload, dA@finir le mot de passe, le mode de partage
(lien+mot de passe) et pour rA@cupA®rer le lien dA®fini par owncloud

2. le mail est prA©-rA@digA® et contient les variables
* adresse de I'AGIA ve

* la date du test

* prA@nom de I'ACIA ve

* note de I'AGIA ve

* lien du partage owncloud sur la copie de I'AGIA ve

* mot de passe sur ce partage

Par exemple :

Bonjour $prenom

Votre note au test du $date est $note. Vous pouvez rA@cupA@rer votre au

copie au lien suivant :
$lien
Le mot de passe pour accA@der Al ce lien est $passwd

Cordialement
Signature

L'adresse est forgA®@e en utilisant le nom du fichier pdf, car les adresses des A@IA ves sont formatA®©es prenom.nom@institution.fr. Mais on

peut trA’s bien les extraire d'un fichier (p.ex. comme lorsqu'on utilise la fonctionnalitA® d'envoi par mail d'’AMC)

Le mail est envoyA® par msmtp

De plus, le script temporise I'envoi de mail. Je n‘ai le droit d'envoyer que N mails par heure. Donc le script effectue une pause d'une heure dans I'envoi
de mails tous les (N-1) mails.

VoilAl . Je me disais que ce serait bien d'intA@grer un truc du genre dans AMC, mais je ne sais pas faire....

09/23/2016 10:50 am - Alexis Bienveniie

C'est intéressant. Le probléme est la multitude de plate-formes de mise a disposition des copies corrigées (j'ai aussi mon petit script pour envoyer les
copies sur spiralconnect, que nous utilisons dans mon université).

L'intégration a AMC est un plus, mais cela demandera un peu de travail surtout si on veut le rendre suffisamment flexible...
Peut-étre pouvez-vous commencer par publier votre script et en expliquer I'utilisation sur le wiki ?

09/23/2016 05:40 pm - olivier torres

J'ai écrit une petite page sur le
"wiki":http://project.auto-multiple-choice.net/projects/auto-multiple-choice/wiki/Script_permettant_d'interfacer_les_sorties_d'AMC_avec_les_partages_O
wncloud. J'y ai déposé mon script

09/21/2018 04:39 pm - Al DUS
Je me permets de relancer la feature car j'ai le méme besoin pour les mémes raisons plus le fait que certaine messageries n'acceptent pas la taille des
copies + corrigé + annotations.

Le fait d'avoir un programme extérieur a lancer ne m'emballe pas trop, car il faut le lancer etc. ¢a rajoute des étapes.

Une solution élégante pourrait éviter la dépendance aux plateformes. Ce serait de pouvoir paramétrer le texte d'accompagnement des copies et de
pouvoir extraire du méme fichier qui donne le nom des éléves, des substituants comme un nom de fichier codé, un lien racine d'un dossier, etc.

On pourrait avoir le méme type de substitution qu'on a pour élaborer le nom de fichier (on devrait d'ailleurs pouvoir recycler ce bout de programme

pour cette extension).
